// generated by CommonLibrary.cmake, do not edit.

/**
 * @file include/pression/version.h
 * Defines version macros and class for library Pression.
 */

#ifndef PRESSION_VERSION_H
#define PRESSION_VERSION_H

#include <pression/api.h>
#include <string>

namespace pression
{
    /** The current major version. */
#   define PRESSION_VERSION_MAJOR 1

    /** The current minor version. */
#   define PRESSION_VERSION_MINOR 1

    /** The current patch level. */
#   define PRESSION_VERSION_PATCH 1

    /** The current SCM revision. */
#   define PRESSION_VERSION_REVISION 0x0

    /** The current binary interface. */
#   define PRESSION_VERSION_ABI 2

/** True if the current version is newer than the given one. */
#   define PRESSION_VERSION_GT( MAJOR, MINOR, PATCH )       \
    ( (PRESSION_VERSION_MAJOR>MAJOR) ||                     \
      (PRESSION_VERSION_MAJOR==MAJOR && (PRESSION_VERSION_MINOR>MINOR || \
          (PRESSION_VERSION_MINOR==MINOR && PRESSION_VERSION_PATCH>PATCH))))

/** True if the current version is equal or newer to the given. */
#   define PRESSION_VERSION_GE( MAJOR, MINOR, PATCH )       \
    ( (PRESSION_VERSION_MAJOR>MAJOR) ||                     \
      (PRESSION_VERSION_MAJOR==MAJOR && (PRESSION_VERSION_MINOR>MINOR || \
          (PRESSION_VERSION_MINOR==MINOR && PRESSION_VERSION_PATCH>=PATCH))))

/** True if the current version is older than the given one. */
#   define PRESSION_VERSION_LT( MAJOR, MINOR, PATCH )       \
    ( (PRESSION_VERSION_MAJOR<MAJOR) ||                     \
      (PRESSION_VERSION_MAJOR==MAJOR && (PRESSION_VERSION_MINOR<MINOR || \
          (PRESSION_VERSION_MINOR==MINOR && PRESSION_VERSION_PATCH<PATCH))))

/** True if the current version is older or equal to the given. */
#   define PRESSION_VERSION_LE( MAJOR, MINOR, PATCH )       \
    ( (PRESSION_VERSION_MAJOR<MAJOR) ||                     \
      (PRESSION_VERSION_MAJOR==MAJOR && (PRESSION_VERSION_MINOR<MINOR || \
        (PRESSION_VERSION_MINOR==MINOR && PRESSION_VERSION_PATCH<=PATCH))))

/** Information about the current Pression version. */
class PRESSION_API Version
{
public:
    /** @return the current major version of Pression. */
    static int getMajor();

    /** @return the current minor version of Pression. */
    static int getMinor();

    /** @return the current patch level of Pression. */
    static int getPatch();

    /** @return the current Pression version (MM.mm.pp). */
    static std::string getString();

    /** @return the SCM revision. */
    static int getRevision();

    /** @return the current binary interface version of Pression. */
    static int getABI();

    /** @return the current Pression version plus the git SHA hash (MM.mm.pp.rev). */
    static std::string getRevString();

    /**
     * Runtime check for ABI compatibility.
     *
     * Call from code using Pression. Will fail if the executable
     * was compiled against a version incompatible with the runtime version.
     *
     * @return true if the link-time and compile-time DSO are compatible.
     */
    static bool check()
    {
        return getMajor()==PRESSION_VERSION_MAJOR &&
               getMinor()==PRESSION_VERSION_MINOR;
    }
};

}

#endif
